#include "machine.h"
/* $Header: common.h,v 2.1 89/09/08 11:51:06 gary Locked $ */


#ifndef EOF
#	include <stdio.h>
#endif

#include <setjmp.h>

#include <math.h>

#define Bool	int
#define true	1
#define false	0
#define C_Pd(x)		IPtr (*x)()


/* Handle BSD vs Sys5 naming convention */

#ifdef StringsH
#	include <strings.h>
#endif

#ifdef StringH
#	include <string.h>
#endif


#ifdef Assert
#	include <assert.h>

#ifdef TURBOC
void _Cdecl abort(void);

#endif

#else
#if defined(Mac)&&defined(Screen)
#	define assert(x)	\
		if(!(x)) {assert_exit(__FILE__, __LINE__);}else
#else
#	define assert(x)	\
		if(!(x)) {mcprintf("assert failed %s %s\n",__FILE__, __LINE__);}else
#endif
#endif


/* Define types of C objects for use in ISETL */
typedef int C_Int;
typedef long int Idx;
typedef FILE *C_File;

#define MathReal	double

#ifdef Double
typedef double C_Real;

#else
typedef float C_Real;

#endif

typedef char *C_Str;
typedef short C_Ref;
typedef char C_Instr;


/*
 * Data of type X must begin on addresses that are multiples of X_Mult
 */

#ifndef Inst_Mult
#define Inst_Mult	sizeof(C_Instr)
#endif

#ifndef Int_Mult
#define Int_Mult	sizeof(C_Int)
#endif

#ifndef Real_Mult
#define Real_Mult	sizeof(C_Real)
#endif

#ifndef Char_Mult
#define Char_Mult	sizeof(char)
#endif

#ifndef Lab_Mult
#define Lab_Mult	sizeof(C_Label)
#endif

#ifndef Ref_Mult
#define Ref_Mult	sizeof(C_Ref)
#endif


#ifdef Void
#	define	void	int
#endif

/* Some systems define constants ITRUE and IFALSE.  Needed as ISETL constants */

#ifdef ITRUE
#	undef	ITRUE
#	undef	IFALSE
#endif


#define Quote		'"'
#define Set_Open	'{'
#define Tuple_Open	'['
#define Set_Close	'}'
#define Tuple_Close	']'

#define Max_Stack	1000
#define Stack_Buffer	30
#define Max_Code	(250)


/* This assumes that C_Real is the largest of all atomic types */

#ifndef Gen_Mult
#   define Gen_Mult	Real_Mult
#endif

/* Definitions for Prototyping */

#ifdef Prototype
#define X	,
#define PTR	IPtr
#define ADDR	*
#define INT	int
#define IDX	Idx
#define C_INT	C_Int
#define PWORKING WORKING
#define PDIGIT	DIGIT
#define NONE	void
#define C_FILE	C_File

/* prototypes must be widened to match oldstyle definitions */
#define BOOL	int
#define CHAR    int
#define C_REF	int
#define C_INSTR int


#define STR	C_Str
#define C_REAL	C_Real
#define TAGS	Type_Tags
#define C_LABEL C_Label
#define AST_PTR AST_Ptr
#define MORE	...
#define MATHFUNC	MathReal(*f)(MathReal)
#define PTRFUNC		IPtr(*f)(MathReal)
#define MATHREAL	MathReal
#define ARRAY		[]


#else
#define X
#define PTR
#define ADDR
#define INT
#define IDX
#define C_INT
#define PWORKING
#define PDIGIT
#define NONE
#define BOOL
#define C_FILE
#define CHAR
#define STR
#define C_REAL
#define TAGS
#define C_REF
#define C_INSTR
#define C_LABEL
#define AST_PTR
#define MORE
#define MATHFUNC
#define MATHREAL
#define PTRFUNC
#define ARRAY
#endif


#include "types.h"
#include "debug.h"
#include "mp.h"

extern FILE *fopen();
#ifdef Mac
extern FILE *FOpen();
#else
#define FOpen(f,m) fopen(f,m)
#endif

extern void do_exit(INT);

extern FILE *FNULL;
extern char *CNULL;

#ifndef EOS
#	define	EOS	'\0'
#endif


#ifdef FileExt
#	define	MAX_FN	12
#endif

#ifndef FileExt
#	define	MAX_FN	20
#endif

extern jmp_buf err_ret;
extern void Print_Id(C_REF);

extern IPtr NilT;
extern IPtr NilHT;
extern IPtr Nil;
extern IPtr OM;
extern IPtr ITRUE;
extern IPtr IFALSE;
extern IPtr BigOne;
extern IPtr BigTwo;
extern IPtr BigTen;

extern IPtr Environment;
extern IPtr AStack[];
extern IPtr *Top;

extern AST_Ptr parsed;
extern C_Ref Anons;
extern IPtr New_Code,
        Tail_Code;		       /* Code Queue */
extern Exec_Point PC;
extern struct Block Working_Code;

extern long max_mem;
extern long current_mem;
extern char *last_prompt;

extern Bool gc_debug;
extern Bool instruction_printing;
extern Bool trace_debug;
extern Bool loading;
extern Bool silent;
extern Bool inside;
extern Bool silent_running;
extern Bool direct_input;
extern Bool edit_flag;
extern Bool echo_mode;
extern Bool editting;
extern Bool single_step;
extern int  call_level;

extern void Init_Signals(NONE);
extern void Hold_Signals(NONE);
extern int yyparse(NONE);
extern void Id_Dump(BOOL);
extern void Watch(STR);
extern void UnWatch(STR);
extern Bool Watched(INT);
extern Bool Add_Segment(NONE);

extern void reset_line(NONE);
extern void no_prompt(BOOL);

#ifndef Screen
	extern int ile_getc(NONE);
#endif

extern void on_int(INT);
extern void start_raw(NONE);
extern void _main(INT X STR ADDR);

#ifdef TURBOC
#include <stdlib.h>

#else
#ifdef Mac
#include <stdlib.h>

#else
extern char *malloc(INT);
extern void free(STR);

#endif
#endif

#ifdef Screen
#ifdef TURBOC
extern char io_temp[];
#  define  mcputc(c)			if(direct_input) putchar(c);\
					else Eputc(c)
#  define  mcfputc(c,f)			{if(f==stdout)mcputc(c);\
					 else         putc(c,f);}
#  define  mcprintf(form,a1,a2)		{sprintf(io_temp, form,a1,a2);\
                                         mcEputs();}
#  define  mcfprintf(f,form,a1,a2)	{sprintf(io_temp, form,a1,a2);\
                                         mcEfputs(f);}
#  define  mcfflush(f) (f == stdout && !direct_input ? Eflush() : fflush(f))
extern void mcEputs(NONE), mcEfputs(C_FILE), Eputc(CHAR);
#endif
#ifdef Mac
extern char io_temp[];
#  define  mcputc(c)			Eputc(c)
#  define  mcfputc(c,f)			{if(f==stdout)mcputc(c);\
					 else         putc(c,f);}
#  define  mcprintf(form,a1,a2)		{sprintf(io_temp, form,a1,a2);\
                                         mcEputs();}
#  define  mcfprintf(f,form,a1,a2)	{sprintf(io_temp, form,a1,a2);\
                                         mcEfputs(f);}
#  define  mcfflush(f) (f == stdout ? Eflush() : fflush(f))
extern void mcEputs(NONE), mcEfputs(C_FILE), Eputc(CHAR);
#endif
#else
#  define  mcputc(c)			putchar(c)
#  define  mcfputc(c,f)			putc(c,f)
#  define  mcprintf(form,a1,a2)		printf(form,a1,a2)
#  define  mcfprintf(f,form,a1,a2)	fprintf(f,form,a1,a2)
#  define  mcfflush(f) fflush(f)
#endif

#ifdef Index
#  define index strchr
#endif

#ifdef Screen
#   ifdef TURBOC
#   include "editor.h"
#   endif
#   ifdef Mac
      extern char * prompt_chars;
#	endif
#endif
	

